package formresizing.example.client.ui.forms;

import org.eclipse.scout.commons.annotations.Order;
import org.eclipse.scout.commons.exception.ProcessingException;
import org.eclipse.scout.rt.client.ui.form.AbstractForm;
import org.eclipse.scout.rt.client.ui.form.AbstractFormHandler;
import org.eclipse.scout.rt.client.ui.form.fields.button.AbstractButton;
import org.eclipse.scout.rt.client.ui.form.fields.button.AbstractCancelButton;
import org.eclipse.scout.rt.client.ui.form.fields.button.AbstractOkButton;
import org.eclipse.scout.rt.client.ui.form.fields.groupbox.AbstractGroupBox;
import org.eclipse.scout.rt.client.ui.form.fields.stringfield.AbstractStringField;

import formresizing.example.client.ui.forms.BigForm.MainBox.AButton;
import formresizing.example.client.ui.forms.BigForm.MainBox.ATextField;
import formresizing.example.client.ui.forms.BigForm.MainBox.BButton;
import formresizing.example.client.ui.forms.BigForm.MainBox.CancelButton;
import formresizing.example.client.ui.forms.BigForm.MainBox.OkButton;

public class BigForm extends AbstractForm {

  public BigForm() throws ProcessingException {
    super();
  }

  public void startDisplay() throws ProcessingException {
    startInternal(new DisplayHandler());
  }

  public CancelButton getCancelButton() {
    return getFieldByClass(CancelButton.class);
  }

  public MainBox getMainBox() {
    return getFieldByClass(MainBox.class);
  }

  public OkButton getOkButton() {
    return getFieldByClass(OkButton.class);
  }

  public ATextField getATextField() {
    return getFieldByClass(ATextField.class);
  }

  public AButton getAButton() {
    return getFieldByClass(AButton.class);
  }

  public BButton getBButton() {
    return getFieldByClass(BButton.class);
  }

  @Override
  protected String getConfiguredTitle() {
    return getClass().getSimpleName();
  }

  @Order(10.0)
  public class MainBox extends AbstractGroupBox {

    @Override
    protected int getConfiguredGridH() {
      return 250;
    }

    @Override
    protected boolean getConfiguredGridUseUiHeight() {
      return false;
    }

    @Order(10.0)
    public class AButton extends AbstractButton {
      @Override
      protected String getConfiguredLabel() {
        return getClass().getSimpleName();
      }

      @Override
      protected void execClickAction() throws ProcessingException {
        getBButton().setVisible(true);
      }
    }

    @Order(20.0)
    public class ATextField extends AbstractStringField {
      @Override
      protected String getConfiguredLabel() {
        return getClass().getSimpleName();
      }

      @Override
      protected boolean getConfiguredMultilineText() {
        return true;
      }

      @Override
      protected int getConfiguredGridH() {
        return 2;
      }

      @Override
      protected int getConfiguredGridW() {
        return 2;
      }
    }

    @Order(30.0)
    public class BButton extends AbstractButton {
      @Override
      protected String getConfiguredLabel() {
        return getClass().getSimpleName();
      }

      @Override
      protected boolean getConfiguredVisible() {
        return false;
      }
    }

    @Order(100.0)
    public class OkButton extends AbstractOkButton {
    }

    @Order(200.0)
    public class CancelButton extends AbstractCancelButton {
    }
  }

  public class DisplayHandler extends AbstractFormHandler {

    @Override
    protected void execLoad() throws ProcessingException {
      String string = "";
      string += "Click on the AButton to make BButton visible \n";
      string += "\n";
      string += "Press escape if you do not see the Cancel Button";
      getATextField().setValue(string);
    }
  }

}
