/*******************************************************************************
 * Copyright (c) 2010 BSI Business Systems Integration AG.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     BSI Business Systems Integration AG - initial API and implementation
 ******************************************************************************/
package formresizing.example.ui.swing.custom.jcomponents;

import java.awt.Dialog;
import java.awt.Frame;
import java.awt.GraphicsConfiguration;

import javax.swing.JRootPane;

import org.eclipse.scout.rt.ui.swing.ext.JDialogEx;

public class SampleJDialogEx extends JDialogEx {

  private static final long serialVersionUID = 1L;

  public SampleJDialogEx() {
    super();
  }

  public SampleJDialogEx(Dialog d) {
    super(d);
  }

  public SampleJDialogEx(Dialog d, boolean modal) {
    super(d, modal);
  }

  public SampleJDialogEx(Dialog d, String title) {
    super(d, title);
  }

  public SampleJDialogEx(Dialog d, String title, boolean modal) {
    super(d, title, modal);
  }

  public SampleJDialogEx(Dialog d, String title, boolean modal, GraphicsConfiguration gc) {
    super(d, title, modal, gc);
  }

  public SampleJDialogEx(Frame f) {
    super(f);
  }

  public SampleJDialogEx(Frame f, boolean modal) {
    super(f, modal);
  }

  public SampleJDialogEx(Frame f, String title) {
    super(f, title);
  }

  public SampleJDialogEx(Frame f, String title, boolean modal) {
    super(f, title, modal);
  }

  public SampleJDialogEx(Frame f, String title, boolean modal, GraphicsConfiguration gc) {
    super(f, title, modal, gc);
  }

  @Override
  protected JRootPane createRootPane() {
    SampleJRootPaneEx rp = new SampleJRootPaneEx() {
      private static final long serialVersionUID = 1L;

      @Override
      protected void reflow() {
        SampleJDialogEx.this.pack();
      }
    };
    rp.setName("Synth.Dialog");
    return rp;
  }

}
