/*******************************************************************************
 * Copyright (c) 2010 BSI Business Systems Integration AG.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     BSI Business Systems Integration AG - initial API and implementation
 ******************************************************************************/
package formresizing.example.ui.swing.custom.jcomponents;

import java.awt.Dimension;

import org.eclipse.scout.rt.ui.swing.SwingLayoutUtility;
import org.eclipse.scout.rt.ui.swing.ext.JRootPaneEx;

public class SampleJRootPaneEx extends JRootPaneEx {

  private static final long serialVersionUID = 1L;

  @Override
  protected void evaluateReflow() {
    if (getParent() == null || !isVisible() || !isShowing()) {
      return;
    }
    // check minSize and maxSize requirements
    Dimension d = getSize();
    if (d.width > 0 && d.height > 0) {
      Dimension[] sizes = SwingLayoutUtility.getValidatedSizes(SampleJRootPaneEx.this);
      Dimension minMaxSize = new Dimension(
          Math.min(Math.max(d.width, sizes[0].width), sizes[2].width),
          Math.min(Math.max(d.height, sizes[0].height), sizes[2].height)
          );
      int dw = minMaxSize.width - d.width;
      int dh = minMaxSize.height - d.height;
      //int dwPref = sizes[1].width - d.width;
      //int dhPref = sizes[1].height - d.height;
      //OLD: if (dw != 0 || dh != 0 || dwPref != 0 || dhPref != 0) {
      //NEW: only force re-pack when min/max is not met, forcing preferred size breaks the bugs https://bugs.eclipse.org/bugs/show_bug.cgi?id=363148 and tickets 107768, 106554
      //     do not consider 
      if (dw != 0 || dh != 0) {
        super.reflow();
      }
    }
  }
}
